]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: uncomment and refactor function chlo
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             . /etc/bash_completion.d/*
80          fi
81       elif [ "$SHELL" = /usr/local/bin/bash ]; then
82          if [ -d /usr/local/etc/bash_completion.d ]; then
83             . /usr/local/etc/bash_completion.d/*
84          fi
85       else
86          echo "Unknown OS type, canot source bash_completion" >&2
87       fi
88    fi
89
90    has_completion() { return 0; }
91    if [ "$SHELL" = /bin/bash ]; then
92       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
93          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
94       fi
95    elif [ "$SHELL" = /usr/local/bin/bash ]; then
96       if [ -d /usr/local/etc/bash_completion.d ]; then
97          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog completion_f programs
121       prog="$1"
122       completion_f="$2"
123       shift; shift
124       programs="$@"
125       if has_completion "$prog"; then
126          eval "_${prog}_completion_loader() {
127             _completion_loader $prog
128             complete -F $completion_f $programs
129             unset _${prog}_completion_loader
130             return 124
131          }"
132          complete -F _"$prog"_completion_loader $programs
133       fi
134    }
135
136    delegate_completion make _make m
137    delegate_completion rsync _rsync r
138    delegate_completion ssh _ssh s
139    delegate_completion wget _wget wget-m wget-wrapper ww
140
141    unset has_completion delegate_completion
142
143    complete -A job bg fg j jobs wait
144    complete -A variable -A function unset
145
146    if [ -d "$HOME/lib/config" ]; then
147       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
148    fi
149    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
150
151    #if type -p pip >/dev/null 2>&1; then
152    #   eval "`pip completion --bash`"
153    #   rm -rf /tmp/pip_build_"$USER"
154    #fi
155
156 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
157    back() { cd - "$@"; }
158    j() { jobs; }
159 fi
160
161
162 # clear screen and history, logout
163 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
164
165
166 if test -x /usr/bin/git >/dev/null 2>&1; then
167    # chdir to a remote's directory (if the remote is on the local FS)
168    cdremote() {
169       if [ -z "$1" -o -n "$2" ]; then
170          echo "Usage: cdremote remote_name" >&2
171          return 1
172       fi
173       cd "`git config --get remote.$1.url`"
174    }
175
176    if test -n "$BASH_VERSION"; then
177       # completion for global aliases in .gitconfig
178
179       # fixup rbi rbia rbiap rbip - do refs name completion
180       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
181       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
182       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
183       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
184       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
185       #
186       # push-to-all-remotes - do branch name completion
187       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
188
189       # list remotes with URLs matching a regexp
190       _list_remotes() {
191          if [ -z "$1" -o -n "$2" ]; then
192             echo "Usage: _list_remotes remote_regexp" >&2
193             return 1
194          fi
195          GIT_REMOTES=""
196          local remote
197          for remote in `git remote`; do
198             if git config --get remote.$remote.url | grep -q "$1"; then
199                GIT_REMOTES="$GIT_REMOTES $remote"
200             fi
201          done
202       }
203
204       # completion for cdremote and git-open - list remotes with a pattern
205       _list_remotes_completion() {
206          local cur="${COMP_WORDS[COMP_CWORD]}";
207          _list_remotes "$1"
208          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
209          unset GIT_REMOTES
210       }
211
212       # completion for cdremote - list remotes with directories as URLs
213       _cdremote_complete() {
214          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
215       }
216
217       complete -F _cdremote_complete cdremote
218
219       # completion for git-open - list remotes with http(s) URLs
220       _git_open() {
221          _list_remotes_completion '^http\(s\)\?://'
222       }
223
224       complete -F _git_open git-open
225    fi
226 fi
227
228
229 include() {
230    cfg="$1"
231    if [ -f "./$cfg" -a -r "./$cfg" ]; then
232       echo "Reading config file \`$cfg'" 1>&2
233       . "./$cfg"
234    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
235       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
236       . "$HOME/lib/config/$cfg"
237    else
238       echo "Cannot find config file \`$cfg'" 1>&2
239    fi
240 }
241
242
243 mc() {
244    if test -n "$BASH_VERSION"; then
245       MC_SAVE_OPS1="$OPS1"
246       OPS1="\u@\h "
247    fi
248
249    if [ -n "$SLOWTERM" ]; then
250       MC_SLOW="--slow"
251    fi
252
253    case "$TERM" in
254       screen*) # screen, screen.rxvt
255          if [ "$TERM" = screen.rxvt ]; then
256             MC_SAVE_TERM="$TERM"
257             TERM=rxvt
258          fi
259          MC_XTERM="-x"
260       ;;
261    esac
262
263    #TMPDIR="$HOME"/tmp
264    #export TMPDIR
265
266    MC_FOUND=NO
267
268    for wrapper in \
269          /usr/local/share/mc/bin/mc-wrapper.sh \
270          /usr/local/libexec/mc/mc-wrapper.sh \
271          /usr/share/mc/bin/mc-wrapper.sh; do
272       if [ -r $wrapper ]; then
273          . $wrapper $MC_SLOW $MC_XTERM "$@"
274          rc=$?
275          MC_FOUND=YES
276          break
277       fi
278    done
279
280    if [ $MC_FOUND = NO ]; then
281       for mc in /usr/local/bin/mc /usr/bin/mc; do
282          if [ -x $mc ]; then
283             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
284             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
285                MC_TMP_DIR="${TMPDIR-/tmp}"
286             fi
287             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
288             mc_type="`mc_type.py $mc`"
289             if [ "$mc_type" = old ]; then
290                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
291             elif [ "$mc_type" = new ]; then
292                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
293             else
294                continue
295             fi
296             rc=$?
297             MC_FOUND=YES
298             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
299             break
300          fi
301       done
302    fi
303
304    if [ $MC_FOUND = NO ]; then
305       echo "Cannot find mc-wrapper.sh or mc" >&2
306       rc=1
307    fi
308
309    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
310    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
311    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
312          MC_SLOW MC_TMP_DIR MC_XTERM
313
314    return $rc
315 }
316
317
318 mkcd() {
319    if [ $# -ne 1 ]; then
320       echo "Usage: mkcd directory_name" >&2
321    elif [ -d "$1" ]; then
322       cd "$1"
323    elif [ -e "$1" ]; then
324       echo "Error: $1 is a file" >&2
325    else
326       mkdir -p "$1" && cd "$1"
327    fi
328 }
329
330
331 if which tmux >/dev/null 2>&1; then
332    tmux() {
333       case "$TERM" in
334          rxvt)
335             TERM=rxvt-unicode command tmux "$@"
336          ;;
337
338          *)
339             command tmux "$@"
340          ;;
341       esac
342    }
343 fi
344
345
346 #if which pyenv >/dev/null 2>&1; then
347 #   eval "`pyenv init -`"
348 #   eval "`pyenv virtualenv-init -`"
349 #fi
350
351 if [ -f /usr/local/bin/virtualenvwrapper_lazy.sh ]; then
352    source /usr/local/bin/virtualenvwrapper_lazy.sh
353 fi
354
355
356 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
357    X() { startx >> .Xserver.log 2>&1; cyr; }
358 fi
359
360 x() { exit; }